;#####################################################
;#               THE CYBERDOOM SYSTEMS               #
;#                Simple Animation                   #
;#                     Example                       #
;#####################################################

        .486
        .model flat,stdcall
        option casemap:none   ; case sensitive

; ####################################################

        include \masm32\include\windows.inc
        include \masm32\include\user32.inc
        include \masm32\include\kernel32.inc
        include \masm32\include\gdi32.inc
        include \masm32\include\comctl32.inc

        includelib \masm32\lib\user32.lib
        includelib \masm32\lib\kernel32.lib
        includelib \masm32\lib\gdi32.lib
        includelib \masm32\lib\comctl32.lib

; ####################################################

    
        ID_BUTTON   equ 300
        ID_TIMER    equ 400
        LEFT        equ 20 
        TOP         equ 63
        BMP_WIDTH   equ 110
        BMP_HEIGHT  equ 110

; ----------------------------------------------------

        DlgProc  PROTO :DWORD,:DWORD,:DWORD,:DWORD
        Paint_it PROTO :DWORD,:DWORD
        

; ----------------------------------------------------

    .data        
himage      dd offset himages


; --------------------------------------------------------------------------

    .data?
hInstance   dd ?
flag        db ?
himages     db 4*4 dup(?);     4 ( = 4*5  ..)
      
; --------------------------------------------------------------------------

    .code

start:

; ###############################################################

        invoke GetModuleHandle,NULL
        mov hInstance,eax
        
; -------------------------------------------
; Call the dialog box stored in resource file
; -------------------------------------------
        invoke DialogBoxParam,hInstance,100,0,ADDR DlgProc,0
        invoke ExitProcess,0

; ###############################################################

DlgProc proc hWin:DWORD,uMsg:DWORD,aParam:DWORD,bParam:DWORD

    LOCAL Ps:PAINTSTRUCT

        .if uMsg ==   WM_INITDIALOG
                   
                       
                       mov esi,1
                       mov edi,offset himages
                       @@:
                       invoke LoadImage,hInstance,esi,IMAGE_BITMAP,0,0,
                                         LR_LOADTRANSPARENT or LR_LOADMAP3DCOLORS
                       mov [edi], eax
                       add esi,1
                       cmp esi,5
                       je @F; 4  
                       add edi,4;  dword     
                       jmp @B  
                       @@:                       
                    
                       invoke SetTimer,hWin,ID_TIMER,100,0
                       invoke SetFocus,hWin

        .elseif uMsg == WM_COMMAND
                        mov eax,aParam
                        .if eax == ID_BUTTON
                            invoke SendMessage,hWin,WM_CLOSE,NULL,NULL
                        .endif

        .elseif uMsg == WM_NOTIFY
                       
        .elseif uMsg == WM_PAINT
                        invoke BeginPaint,hWin,ADDR Ps
                        invoke EndPaint,hWin,ADDR Ps

        .elseif uMsg == WM_CLOSE
                       
                        invoke KillTimer,hWin,ID_TIMER
                        invoke EndDialog,hWin,NULL

        .elseif uMsg == WM_TIMER
        
                         inc flag
                         cmp flag,5;  4
                         jne @F
                         mov flag,0
                         mov himage,offset himages
       
                      @@:
                         mov esi,himage
                         lodsd
                         invoke Paint_it,hWin,eax
                         add himage,4;  dword
        
        .endif

                         xor eax,eax
                         ret
                    
DlgProc endp



Paint_it proc hWin:DWORD, hImage:DWORD

    LOCAL hDC:DWORD
    LOCAL memDC:DWORD


                    invoke GetDC,hWin
                    mov hDC,eax
                    invoke CreateCompatibleDC,hDC
                    mov memDC,eax
                    invoke SelectObject,memDC,hImage
                    invoke BitBlt,hDC,LEFT,TOP,BMP_WIDTH,BMP_HEIGHT,memDC,0,0,SRCCOPY
                    invoke DeleteDC,memDC
                    invoke ReleaseDC,hWin,hDC
                    ret

Paint_it endp

; ###############################################################

end start
